
local MakePlayerCharacter = require "prefabs/player_common"


local assets = {Asset("SCRIPT", "scripts/prefabs/player_common.lua")}

local prefabs = { }

local start_inv = { "goldenaxe", "goldenshovel", "goldenpickaxe", "gears"}

local function onbecamehuman(inst)

	inst.components.locomotor:SetExternalSpeedMultiplier(inst, "shiro_speed_mod", 1)
	
end

local function onbecameghost(inst)

   inst.components.locomotor:RemoveExternalSpeedMultiplier(inst, "shiro_speed_mod")
   
end

local function onload(inst)

    inst:ListenForEvent("ms_respawnedfromghost", onbecamehuman)
    inst:ListenForEvent("ms_becameghost", onbecameghost)

    if inst:HasTag("playerghost") then
	
        onbecameghost(inst)
		
    else
	
        onbecamehuman(inst)
		
    end
	
end

local common_postinit = function(inst) 

	inst.MiniMapEntity:SetIcon( "shiro.tex" )
	
end

local function onsave(inst, data)

	data.maxhealth = inst.components.health.maxhealth or nil
	data.maxhunger = inst.components.hunger.max or nil
	data.maxsanity = inst.components.sanity.max or nil
	data.absorb = inst.components.health.absorb or nil
	data.hungerrate = inst.components.hunger.hungerrate or nil
	data.aura_mult = inst.components.sanity.neg_aura_mult or nil
	data.drain_mult = inst.components.sanity.night_drain_mult or nil
	data.damagemultiplier = inst.components.combat.damagemultiplier or nil
	data.dapperness = inst.components.sanity.dapperness or nil
	data.inherentinsulation = inst.components.temperature.inherentinsulation or nil
	data.walkspeed = inst.components.locomotor.walkspeed or nil
	data.runspeed = inst.components.locomotor.runspeed or nil
	
end

local function onpreload(inst, data)

		inst.components.health:SetMaxHealth(data.maxhealth)
		inst.components.hunger:SetMax(data.maxhunger)
		inst.components.sanity:SetMax(data.maxsanity)
		inst.components.health.absorb = data.absorb
		inst.components.hunger.hungerrate = data.hungerrate
		inst.components.sanity.neg_aura_mult = data.aura_mult
		inst.components.sanity.night_drain_mult = data.drain_mult
		inst.components.combat.damagemultiplier = data.damagemultiplier
		inst.components.sanity.dapperness = data.dapperness
		inst.components.temperature.inherentinsulation = data.inherentinsulation
		inst.components.locomotor.walkspeed = data.walkspeed
		inst.components.locomotor.runspeed = data.runspeed
		
end

local function genius(inst)

	if inst.components.sanity.current >= (90) and inst.components.sanity.current <= (120) then 
	
		inst.components.builder.science_bonus = (3)
		inst.components.builder.magic_bonus = (3)
		inst.components.builder.ancient_bonus = (3)
		inst.components.builder.volcanic_bonus = (3)
		
    elseif inst.components.sanity.current >= (60) and inst.components.sanity.current < (90) then 
		
		inst.components.builder.science_bonus = (2)
		inst.components.builder.magic_bonus = (2)
		inst.components.builder.ancient_bonus = (2)
		inst.components.builder.volcanic_bonus = (2)
		
    elseif inst.components.sanity.current >= (30) and inst.components.sanity.current < (60)then 

		inst.components.builder.science_bonus = (1)
		inst.components.builder.magic_bonus = (1)
		inst.components.builder.ancient_bonus = (1)
		inst.components.builder.volcanic_bonus = (1)
		
	elseif inst.components.sanity.current > (0) and inst.components.sanity.current < (30) then 
		
		inst.components.builder.science_bonus = (0)
		inst.components.builder.magic_bonus = (0)
		inst.components.builder.ancient_bonus = (0)
		inst.components.builder.volcanic_bonus = (0)
	
	end
	
end


local function superhunger(inst)

	inst.components.hunger:DoDelta(-6)

	end
	
	local function levelup(inst)

		if inst.components.health.maxhealth <= (240) then
			inst.components.health.maxhealth = (inst.components.health.maxhealth + 1)
			
		end
		
		if  inst.components.sanity.max <= (180) then
			inst.components.sanity.max = (inst.components.sanity.max + 1)
			
		end
		
		if  inst.components.hunger.max <= (150) then
			inst.components.hunger.max = (inst.components.hunger.max + 1)

		end
		
	end
	
local function cuteequip(inst, data)

	local item = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)

		if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) ~= nil then

		inst.components.health.absorb = (0.00)
		
		end
					
end
	
local function cuteunequip(inst, data)

	local item = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)

		if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) == nil then

		inst.components.health.absorb = (0.60)
		
		end
					
end
	
local master_postinit = function(inst)

	inst.soundsname = "willow"
	
	inst.components.health:SetMaxHealth(120)
	inst.components.hunger:SetMax(90)
	inst.components.sanity:SetMax(75)
	inst.components.health.absorb = (0.00)
	inst.components.hunger.hungerrate = (TUNING.WILSON_HUNGER_RATE * 0.90)
	inst.components.sanity.neg_aura_mult = (0.90)
	inst.components.sanity.night_drain_mult = (0.90)
	inst.components.combat.damagemultiplier = (1.00)
	inst.components.sanity.dapperness = (TUNING.DAPPERNESS_MED * 0.00)
	inst.components.temperature.inherentinsulation = (TUNING.INSULATION_PER_BEARD_BIT * 0.03)
	inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.03)
	inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.03)
	inst.components.builder.science_bonus = (3)
	inst.components.builder.magic_bonus = (3)
	inst.components.builder.ancient_bonus = (3)
	inst.components.builder.volcanic_bonus = (3)
	
	inst:ListenForEvent("sanitydelta", function(inst) genius(inst) end)
	inst:ListenForEvent("attacked", function(inst) superhunger(inst) end)
	inst:ListenForEvent("killed", function(inst) levelup(inst) end)
	inst:ListenForEvent("equip", function(inst, data) cuteequip(inst, data) end)
	inst:ListenForEvent("unequip", function(inst, data) cuteunequip(inst, data) end)
	
	inst.OnSave = onsave
	inst.OnLoad = onload
    inst.OnNewSpawn = onload
	inst.OnPreLoad = onpreload
	
	genius(inst)
	
	return inst
	
end

return MakePlayerCharacter("shiro", prefabs, assets, common_postinit, master_postinit, start_inv)

--Current Mod Version: [1.0.7]
--Current Mod Build: [10714012017]

--DST Character Mod Author: Senshimi [https://steamcommunity.com/id/Senshimi/]
--Community Project Collection: STEAM [http://steamcommunity.com/workshop/filedetails/?id=833197968]
--Touhou Project Collection: STEAM [http://steamcommunity.com/sharedfiles/filedetails/?id=701414094]
